#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <stdio.h>
#include <errno.h>

void message(char *variable, char *message);

/*************************************************************
 *  On utilise les variable d'environement pour paramtrer 
 *  le prcessus
 *  NP le nombre de processus fils
 *  CE code exit de fils
 *  STF sleep time pour le fils
 *  Definir ces variables avant l'execution,
 *  exemple (depuis bash) :
 *  export CE=5
 **************************************************************/

int main(int argc, char **argv){

  pid_t pid;
  char *np,*ec,*stf;
  int i,j;
  char *arg_fils[4];
  int etat;

  arg_fils[0]="fils";


  /* nombre de processus*/
  np=getenv("NP");
  if( np == NULL ){
    message("NP","nombre de processus");
    return EXIT_FAILURE;
  }
  /*exit code fils*/
  ec=getenv("EC");
  if( ec == NULL){
    message("EC","exit code");
    return EXIT_FAILURE;
  }
  /*sleep time fils*/
  stf=getenv("STF");
  if( stf == NULL){
    message("STF","sleep time fils");
    return EXIT_FAILURE;
  }
  arg_fils[1]=ec;
  arg_fils[2]=stf;
  arg_fils[3]=(char *)NULL;

  j=atoi(np); /* j nombre de fils a creer */
  for(i=0; i<j;i++){
    pid=fork();
    if( pid == -1 ){
      perror(NULL);
      exit(EXIT_FAILURE);
    }

    if( pid == 0 ){/*fils, faire exec*/
      execv("./fils",arg_fils);
      perror("exec");
      return EXIT_FAILURE;
    }

  }/* end for */


  for( ; ; ){
    pid=wait(&etat);
    if( pid == -1 && errno == ECHILD ){/* pas de fils*/
      break;
    }
    if( pid == -1 && errno == EINTR ){/* signal */
      continue;
    }
    printf("le fils [%d] est termine\n",(int)pid);

    if(WIFEXITED(etat)){
      printf("terminaison normale, code retour %d\n", WEXITSTATUS(etat));
    }
    else if(WIFSIGNALED(etat)){
      printf("fils tue par le signal %d\n",WTERMSIG(etat));
    }
  }
  return EXIT_SUCCESS;
} 

void message(char *var,char *mess){
  fprintf(stderr,"%s %s\n",var,mess);
}
