#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <stdio.h>
#include <errno.h>

void message(char *variable, char *message);

int main(int argc, char **argv){

  pid_t pid;
  char *np,*ec,*stf;
  int i,j;
  char *arg_fils[4];
  int etat;
  pid_t *tab;

  /* nombre de processus*/
  np=getenv("NP");
  if( np == NULL ){
    message("NP","nombre de processus");
    return EXIT_FAILURE;
  }
  /*exit code fils*/
  ec=getenv("EC");
  if( ec == NULL){
    message("EC","exit code");
    return EXIT_FAILURE;
  }
  /*sleep time fils*/
  stf=getenv("STF");
  if( stf == NULL){
    message("STF","sleep time fils");
    return EXIT_FAILURE;
  }
  arg_fils[0]="fils";
  arg_fils[1]=ec;
  arg_fils[2]=stf;
  arg_fils[3]=(char *)NULL;

  j=atoi(np);
  tab=malloc(sizeof( pid_t ) * j);

  for(i=0; i<j;i++){
    pid=fork();
    if( pid == -1 ){
      perror(NULL);
      exit(EXIT_FAILURE);
    }

    if( pid == 0 ){/*fils : faire exec*/
      execv("./fils",arg_fils);
      perror("exec");
      return EXIT_FAILURE;
    }
    /* stocker les pid de fils */
    tab[i]=pid;

  }/* end for */

  i=j-1;
  while( i >= 0  ){
    pid=waitpid(tab[i], &etat , WNOHANG);/* attente non bloquante*/
    if( pid == 0 ){ /* les fils n'est pas termine */
      /*      sleep(1);*/ /* faire autre chose */
      printf("fils [%d] non termine\n",(int)tab[i]);
      continue;
    }
    if( pid == -1 && errno == ECHILD ){/* pas de fils*/
      break;
    }
    if( pid == -1 && errno == EINTR ){/* signal */
      continue;
    }

    printf("le fils [%d] est termine\n",(int)pid);

    if(WIFEXITED(etat)){
      printf("terminaison normale, code retour %d\n", WEXITSTATUS(etat));
    }
    else if(WIFSIGNALED(etat)){
      printf("fils tue par le signal : %d\n", WTERMSIG(etat));
    }
    i--;
  }
  return EXIT_SUCCESS;
} 

void message(char *var,char *mess){
  fprintf(stderr,"%s %s\n",var,mess);
}
